﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.Windows.Shared;

namespace ServerSideGrid
{
    public class ModelFilterStatistic
    {
        public List<NumFilterQ> BaseFilter { get; set; }
        public List<NumFilterQ> ParamFilter { get; set; }
        public List<NumFilterQ> PinFilter { get; set; }
        public List<NumFilterQ> SBOFilter { get; set; }
        public List<NumFilterQ> xgFilter { get; set; }
        public List<int> CountryId { get; set; }
        public List<int> LeaguesId { get; set; }
        public List<int> SeasonId { get; set; }
        public List<int> TeamsHomeId { get; set; }
        public List<int> TeamsAwayId { get; set; }
        public int Page { get; set; }
        public int TotalPage { get; set; }
        public int SKip { get; set; }
        public int Count { get; set; }
    }


    public class NumFilterQ
    {
        public NumFilterQ(FilterItem ff)
        {
            Type = ff.Type;
            Name = ff.NameDb;
            if (ff.Max <= ff.MaxValue && ff.Max >= ff.Min)
            {
                if (ff.Max == 0 && ff.MinValue < 0)
                {

                }
                MaxValue = ff.Max.ToString();
            }
            else
            {
                MaxValue = "";
            }
            if (ff.Min != 0 && ff.Min <= ff.MaxValue && ff.Min >= ff.MinValue)
            {
                MaxValue = ff.Max.ToString();
            }
            else
            {
                MaxValue = "";
            }
            MinValue = ff.Min > 0 ? ff.Min.ToString() : "";
        }

        public NumFilterQ()
        {

        }
        public string Name { get; set; }
        public string MinValue { get; set; }
        public string MaxValue { get; set; }
        public int Type { get; set; }
    }
    public class FilterItem : NotificationObject
    {
        public FilterItem()
        {
            ListProperty = new ObservableCollection<SelectableParam>();
        }
        public string FilterType { get; set; }
        public bool IsSelect { get; set; }
        public string Name { get; set; }
        public string NameDb { get; set; }
        private int type { get; set; }
        public int Type
        {
            get
            {
                return type;
            }
            set
            {
                type = value;
            }
        }
        public double MinValue { get; set; }
        public double MaxValue { get; set; }

        private double _min { get; set; }
        private double _max { get; set; }
        public double Min
        {
            get
            {
                return _min;
            }
            set
            {
                if (MinValue > value)
                {
                    _min = MinValue;
                }
                else
                {
                    if (MaxValue < value && MaxValue != 0)
                    {
                        _min = MaxValue;
                    }
                    else
                    {
                        _min = value;
                    }
                }

                RaisePropertyChanged("Min");
            }
        }
        public double Max
        {
            get
            {
                return _max;
            }
            set
            {
                if ((MaxValue < value && MaxValue != 0))
                {
                    _max = MaxValue;
                }
                else
                {
                    if (MinValue > value && MinValue != 0)
                    {
                        _max = MinValue;
                    }
                    else
                    {
                        _max = value;
                    }
                }

                if (Min > _max)
                {
                    _max = Min;
                }

                RaisePropertyChanged("Max");
            }
        }

        public string MinTime { get; set; }
        public string MaxTime { get; set; }

        private ObservableCollection<SelectableParam> listProperty;
        public ObservableCollection<SelectableParam> ListProperty
        {
            get
            {
                return listProperty;
            }
            set
            {
                listProperty = value;
                RaisePropertyChanged("ListProperty");
            }
        }
        public class SelectableParam
        {
            public bool Checked { get; set; }
            public string Name { get; set; }
            public int Id { get; set; }
        }
    }
}
