﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media.Imaging;
using Newtonsoft.Json;
using ServerSideGrid.Properties;
using Syncfusion.UI.Xaml.Utility;
using Syncfusion.Windows.Shared;

namespace ServerSideGrid
{
    public class NavigationDrawerProperties : NotificationObject, IDisposable
    {

      
        public NavigationDrawerProperties()
        {


            _saveCommand = new RelayCommand(SaveObject, CanSave);

            
            StatistickSbobet = new ObservableCollection<StatisctickView>();


        }
        private bool CanSave(object obg)
        {

            return true;
        }



        #region ButtonFilterCommand



        private ICommand _saveCommand;

        public ICommand SaveCommand
        {
            get
            {
                return _saveCommand;
            }
        }


        private async void SaveObject(object obg)
        {
            var filter = new ModelFilterStatistic();
            filter.BaseFilter = new List<NumFilterQ>();
            filter.ParamFilter = new List<NumFilterQ>();
            filter.PinFilter = new List<NumFilterQ>();
            filter.SBOFilter = new List<NumFilterQ>();
            filter.xgFilter = new List<NumFilterQ>();
            filter.CountryId = new List<int>();
            filter.LeaguesId = new List<int>();
            filter.SeasonId = new List<int>();
            filter.TeamsAwayId = new List<int>();
            filter.TeamsHomeId = new List<int>();

            var st2 = await GetSbostatistic(filter);
            if (st2 == null || st2.Count == 0)
            {
                MessageBox.Show("Фильтр не дал результатов. Измените фильтр");
                return;
            }
            StatistickSbobet = new ObservableCollection<StatisctickView>(st2);

           


        }

        #endregion
        
         public static string BaseUrl = "https://localhost:44353";


        public async Task<List<StatisctickView>> GetSbostatistic(ModelFilterStatistic form)
        {
            try
            {
                var client = new HttpClient();
                string stringContent = JsonConvert.SerializeObject(form);
                byte[] buffer = Encoding.UTF8.GetBytes(stringContent);
                ByteArrayContent byteContent = new ByteArrayContent(buffer);
                byteContent.Headers.ContentType = new MediaTypeHeaderValue("application/json");
                client.DefaultRequestHeaders.Accept.Clear();
                //if (!client.DefaultRequestHeaders.Contains("Authorization"))
                //    client.DefaultRequestHeaders.Add("Authorization", $"Bearer {Settings.Default.Token}");
                client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
                HttpResponseMessage httpResponseMessage = await client.PostAsync($"{BaseUrl}/api/Statistic/PostSbostatistic", byteContent);
                HttpResponseMessage response = httpResponseMessage;
                httpResponseMessage = null;
                Task<string> s = response.Content.ReadAsStringAsync();
                List<StatisctickView> obg = JsonConvert.DeserializeObject<List<StatisctickView>>(s.Result);
                return obg;
            }
            catch (Exception e)
            {
                return null;
            }
        }


        public void Dispose()
        {

            if (StatistickSbobet != null)
                StatistickSbobet.Clear();

        }



        private ObservableCollection<StatisctickView> statistickSbobet;
        public ObservableCollection<StatisctickView> StatistickSbobet
        {
            get { return statistickSbobet; }
            set { statistickSbobet = value; RaisePropertyChanged("StatistickSbobet"); }
        }







        //FilterItem
    }
    public class StatisctickView
    {
        public string Match { get; set; }
        public double? P1 { get; set; }
        public double? H { get; set; }
        public double? P2 { get; set; }
        public string XG { get; set; }

        private BaseCommand _TestCommand;
        public BaseCommand TestCommand
        {
            get
            {
                if (_TestCommand == null)
                    _TestCommand = new BaseCommand(TestAction);
                return _TestCommand;
            }
        }

        public void TestAction(object param)
        {

            MessageBox.Show(param.ToString());
        }

    }
}
